/*************************************************************/
/*  This program calls evperfm() with different event queues */
/*  author : Sanjeev on 18th March, 2002                     */
/*************************************************************/
                                        
#include<stdio.h>

void printHelp();
extern evPerfm();

/* main starts here */
main(int argc, char *argv[])
{
  char QMgr[50], typeOfOut, evTypeToMon[5];
  int i, rc, waitInt=10000;

  strcpy(evTypeToMon, "all"); 
  typeOfOut = 'B';
  QMgr[0] = '\0';

  for(i=1; i<argc; i++)
  {
     if( strcmp(argv[i], "-m") == 0 || 
         strcmp(argv[i], "-M") == 0 )
     {
             if(i+1 < argc)
       		strcpy(QMgr, argv[++i]);
             else
             {
                printf("ERROR: No queue manager name\n");
		return -1;
 	     }
     }
     else
     if( strcmp(argv[i], "-o") == 0 ||
         strcmp(argv[i], "-O") == 0)
                typeOfOut = 'F';
     else
     if( strcmp(argv[i], "-s") == 0 ||
         strcmp(argv[i], "-S") == 0)
                typeOfOut = 'S';
     else
     if( strcmp(argv[i], "-w") == 0 ||
         strcmp(argv[i], "-W") == 0)
     {
             if(i+1 < argc)
           	waitInt = atoi(argv[++i]);
             else
             {
                printf("ERROR:  Value not specified\n");
		return -1;
             }
     }
     else
     if( strcmp(argv[i], "-c") == 0 ||
         strcmp(argv[i], "-C") == 0)
   		strcpy(evTypeToMon, "cev");
     else
     if( strcmp(argv[i], "-p") == 0 ||
         strcmp(argv[i], "-P") == 0)
   		strcpy(evTypeToMon, "pev");
     else
     if( strcmp(argv[i], "-q") == 0 ||
         strcmp(argv[i], "-Q") == 0)
                strcpy(evTypeToMon, "qev");   
     else 
     if( strcmp(argv[i], "-h") == 0 ||
         strcmp(argv[i], "-?") == 0)
     {
        printf("I am here\n");
        if( i != 1 )
        {
           printf("ERROR: Invalid parameters\n");
           return -1;
        }
        	printHelp();
                exit(1);
     }
     else
     {
         printf("ERROR: Invalid parameters\n");
         return -1;
     }
  }
  if(strlen(QMgr) == 0)
  {
         printf("ERROR: QMgr not specified\n");
         return -1;
  }

  if (waitInt <= 0 || waitInt > 900000)
  {
     printf("WARNING: Invalid parameter passed to -w, \n"
            "         will take default value 10000\n");
     waitInt = 10000;
  }
  
  printf("Evmon started..\n\n");
  while(1)
  {
    if( strcmp(evTypeToMon, "cev") == 0 || 
        strcmp(evTypeToMon, "all") == 0)
    {
    	rc = evPerfm(QMgr,"SYSTEM.ADMIN.CHANNEL.EVENT",typeOfOut,waitInt); 
    	if( rc != 0)
       		 exit(1);
    }
    if( strcmp(evTypeToMon, "qev") == 0 || 
        strcmp(evTypeToMon, "all") == 0)
    {
    	rc = evPerfm(QMgr,"SYSTEM.ADMIN.QMGR.EVENT",typeOfOut,waitInt);
    	if( rc != 0)
        	exit(1);
    }
    if( strcmp(evTypeToMon, "pev") == 0 || 
        strcmp(evTypeToMon, "all") == 0)
    {
    	rc = evPerfm(QMgr,"SYSTEM.ADMIN.PERFM.EVENT",typeOfOut,waitInt);
    	if( rc != 0)
        	exit(1);
    }
  }   /* end of while */
} /* end of main */

  /* Help funciton */
void printHelp()
{
     printf("SYNOPSIS:\n"
                "evmon -m <qmgr> [-c] [-p] [-q]\n"
                                "[-o] [-s] [-w] [-h/-?]\n\n"

            "DESCRIPTION:\n"
                "evmon will wait for the events and prints it on the screen\n" 
                "or to a file called evmon.log.\n\n"

            "-m    - queue manager name from where you need to monitor\n"
            "        event messages\n\n"
            "-c    - to monitor only channel events, by default all\n\n"
            "-p    - to monitor only performance events, by default all\n\n"
            "-q    - to monitor only qmgr events, by default all\n\n"
            "-o    - output to a file only, it is evmon.log,\n"
            "        by default the ouput will be to both\n\n"
            "-s    - output to stdout only, by default the output \n"
            "        will be to both\n\n"
            "-w    - waiting time on each type of event to happen, \n"
            "        by default it will wait 10000 milliseconds on each queue.\n"
            "        You can have an iterval between 1 and 900000 millisecs\n\n" 
            "-h/-? - Help\n");
} /* end of help */ 


